

-- mCam Grid ver2.3 Copyright. m_plugins / update 0506.2009							
-- toolTip: -Generate layout helper grid-

-------------------------
--camera select mode only!!!!
-------------------------

------------------------------------------------------------------------------------------------
--Golden ratio(Grid Generate)

fn F_MakeGR SELCAM =
(
	allsplGR = #() 

	w = 10.0
	asp=(renderWidth as float) * renderPixelAspect / renderHeight
	l = w/asp

	--Golden ratio

	spxg1 = SplineShape()
	addNewSpline spxg1
	addKnot spxg1 1 #corner #line [-(w/2),0,0]
	addKnot spxg1 1 #corner #line [(w/2),0,0]
	spxg1.pos = [0,(l/8.47),0]
	updateShape spxg1
	
	spxg1.render_renderable = off
	spxg1.render_displayRenderMesh = off
	spxg1.render_useViewportSettings = off
	spxg1.wirecolor = green
	spxg1.name = "mcgGolden_ratioX1"
	append allsplGR spxg1
	
	spxg2 = SplineShape()
	addNewSpline spxg2
	addKnot spxg2 1 #corner #line [-(w/2),0,0]
	addKnot spxg2 1 #corner #line [(w/2),0,0]
	spxg2.pos = [0,-(l/8.47),0]
	updateShape spxg2
	
	spxg2.render_renderable = off
	spxg2.render_displayRenderMesh = off
	spxg2.render_useViewportSettings = off
	spxg2.wirecolor = green
	spxg2.name = "mcgGolden_ratioX2"
	append allsplGR spxg2
	
	spyg1 = SplineShape()
	addNewSpline spyg1
	addKnot spyg1 1 #corner #line [0,(l/2),0]
	addKnot spyg1 1 #corner #line [0,-(l/2),0]
	spyg1.pos = [-(w/8.47),0,0]
	updateShape spyg1
	
	spyg1.render_renderable = off
	spyg1.render_displayRenderMesh = off
	spyg1.render_useViewportSettings = off
	spyg1.wirecolor = green
	spyg1.name = "mcgGolden_ratioY1"
	append allsplGR spyg1
	
	spyg2 = SplineShape()
	addNewSpline spyg2
	addKnot spyg2 1 #corner #line [0,(l/2),0]
	addKnot spyg2 1 #corner #line [0,-(l/2),0]
	spyg2.pos = [(w/8.47),0,0]
	updateShape spyg2
	
	spyg2.render_renderable = off
	spyg2.render_displayRenderMesh = off
	spyg2.render_useViewportSettings = off
	spyg2.wirecolor = green
	spyg2.name = "mcgGolden_ratioY2"
	append allsplGR spyg2
	
	select allsplGR
	SPGR = group selection name: "mcgGolden_ratio"
	SPGR.transform = SELCAM.transform
	SPGR.parent = SELCAM
	
	return SPGR
)
------------------------------------------------------------------------------------------------
--camera select(make attribute and parameter wiring)

fn F_Getcamtype SELCAM MODEL =
(
	case classof SELCAM of
	(
		VRayPhysicalCamera:
		(
			mCamG_atr = attributes mCam_Grid_attributes
			(
				parameters main rollout:params
				(
					fov type:#float ui:fov default:1
					)
						rollout params "mCam Grid Attributes"
					(
						spinner fov "fov (display only)" type:#float range:[0,360,1]
				)
			)
			custAttributes.add SELCAM mCamG_atr
		
			SELCAM.baseObject.mCam_Grid_attributes.fov.controller = Float_Expression () 
			SELCAM.baseObject.film_width.controller = Bezier_Float()
			SELCAM.baseObject.mCam_Grid_attributes.fov.controller.AddScalarTarget "FW" SELCAM.film_width.controller
			SELCAM.baseObject.focal_length.controller = Bezier_Float()@
			SELCAM.baseObject.mCam_Grid_attributes.fov.controller.AddScalarTarget "FL" SELCAM.focal_length.controller
			SELCAM.baseObject.zoom_factor.controller = Bezier_Float()@
			SELCAM.baseObject.mCam_Grid_attributes.fov.controller.AddScalarTarget "ZF" SELCAM.zoom_factor.controller
			SELCAM.baseObject.mCam_Grid_attributes.fov.controller.SetExpression "(2*(atan(FW/(2*FL))))/ZF"
			
			MODEL.parent = SELCAM
			paramWire.connect SELCAM.baseObject.mCam_Grid_attributes[#fov] MODEL.pos.controller[#z_position] "-(10/2)/tan(fov/2.0)"
		)
		default:	messagebox "Sorry ! selected camera isn't support..."
	)
)
------------------------------------------------------------------------------------------------

cam = $

rGR = F_MakeGR cam
F_Getcamtype cam rGR

select cam